import os, sys; sys.path.insert(0, os.path.dirname(os.path.abspath(os.path.join(__file__, os.pardir))))
from Utils.IxLoadRestPyWrapper import *

import time

reportPath = r"C:\\Path\\to\\report.pdf"    # TODO - to be changed by user

try:
    setEnvironment(ip='localhost', apiVersion='v0')  # TODO - to be changed by user
    session = IxSessionWrapper(version="version") # TODO - to be changed by user
    session.start()

    test = session.ixload.test
    chassisChain = session.ixload.chassischain
    chassisList = chassisChain.chassisList
    chassisList.clear()
    chassis = chassisList.appendItem(name="machine_ip") # TODO - to be changed by user
    chassis.refreshConnection()

    activeTest = session.ixload.test.activeTest
    activeTest.enableForceOwnership = True

    # enable rest stat views from preferences
    session.ixload.preferences.enableL23RestStatViews = True

    clientCommunity = activeTest.communityList.appendItem()
    serverCommunity = activeTest.communityList.appendItem()
    clientPortList = clientCommunity.network.portList
    serverPortList = serverCommunity.network.portList

    clientPortList.appendItem(chassisId=1, cardId=1, portId=1).enableCapture = True # TODO - to be changed by user
    serverPortList.appendItem(chassisId=1, cardId=1, portId=2).enableCapture = True # TODO - to be changed by user

    activeTest = session.ixload.test.activeTest
    activeTest.enableForceOwnership = True

    # enable rest stat views and CSV logging from preferences
    session.ixload.preferences.enableL23RestStatViews = True
    session.ixload.preferences.enableRestStatViewsCsvLogging = True
    session.ixload.preferences.saveDataModelSnapshot = True

    dnsClientActivity = clientCommunity.activityList.appendItemIxActivityDNSClient()
    dnsServerActivity = serverCommunity.activityList.appendItemIxActivityDNSServer()

    session.ixload.preferences.allowIPOverlapping = True

    getCommand = dnsClientActivity.agent.pm.dnsConfig.dnsQueries.appendItemIxDnsqueryCommand()
    getCommand.dnsServer = "ip_address" # TODO - to be changed by user

    test.runTest()

    stats = session.ixload.stats
    statName = StatsNameDNSClient()

    while activeTest.currentState == "Running":
        print("Stat values -> %s" % stats.DNSClient.filterValues(
            stats=[statName.kDNSSimulatedUsers, \
                   statName.kDNSTransactions]))
        time.sleep(2)

    while activeTest.currentState != "Unconfigured":
        time.sleep(2)

    # wait for capture to complete
    test.waitForAllCaptureData()

    # generate report
    test.generateRestReport(reportPath) # TODO - to be changed by user

except Exception as ex:
    print("Caught exception -> %s" % (str(ex)))
finally:
    session.closeSession()