import os, sys; sys.path.insert(0, os.path.dirname(os.path.abspath(os.path.join(__file__, os.pardir))))
from Utils.IxLoadRestPyWrapper import *

import time

try:
    setEnvironment(ip='localhost', apiVersion='v0')  # TODO - to be changed by user
    session = IxSessionWrapper(version="version") # TODO - to be changed by user
    session.start()

    test = session.ixload.test
    chassisChain = session.ixload.chassischain
    chassisList = chassisChain.chassisList
    chassisList.clear()
    chassis = chassisList.appendItem(name="machine_ip") # TODO - to be changed by user
    chassis.refreshConnection()

    activeTest = session.ixload.test.activeTest
    activeTest.enableForceOwnership = True

    # enable rest stat views from preferences
    session.ixload.preferences.enableL23RestStatViews = True

    clientCommunity = activeTest.communityList.appendItem()
    serverCommunity = activeTest.communityList.appendItem()
    clientPortList = clientCommunity.network.portList
    serverPortList = serverCommunity.network.portList

    clientPortList.appendItem(chassisId=1, cardId=1, portId=1).enableCapture = False # TODO - to be changed by user
    serverPortList.appendItem(chassisId=1, cardId=1, portId=2).enableCapture = False # TODO - to be changed by user

    activeTest = session.ixload.test.activeTest
    activeTest.enableForceOwnership = True

    # enable rest stat views and CSV logging from preferences
    session.ixload.preferences.enableL23RestStatViews = True
    session.ixload.preferences.enableRestStatViewsCsvLogging = True
    session.ixload.preferences.saveDataModelSnapshot = True

    popClientActivity = clientCommunity.activityList.appendItemIxActivityPOP3Client()
    popServerActivity = serverCommunity.activityList.appendItemIxActivityPOP3Server()

    mail = popServerActivity.agent.mailMessageList.appendItem()
    mail.name = "Simple1"
    mail.enablePatternGen = False
    mail.mimeTypeAndEncode = 0
    mail.description = "100 bytes plain text body"
    mail.bodySizeFixed = 100
    mail.bodySizeRandomMax = 4096
    mail.bodySizeRandomMin = 1
    mail.bodyDataType = 0
    mail.useFileAsBody = True

    getCommand = popClientActivity.agent.commandList.appendItemIxGetCommand()
    getCommand.arguments = "Traffic2_POP3Server1:110"

    test.runTest()

    stats = session.ixload.stats
    statName = StatsNamePOP3Client()

    while activeTest.currentState == "Running":
        print("Stat values -> %s" % stats.POP3Client.filterValues(
            stats=[statName.kSessionsEstablished, \
                   statName.kMailsReceiveds]))
        time.sleep(2)

    while activeTest.currentState != "Unconfigured":
        time.sleep(2)

    # wait for capture to complete
    test.waitForAllCaptureData()

except Exception as ex:
    print("Caught exception -> %s" % (str(ex)))
finally:
    session.closeSession()