import os, sys; sys.path.insert(0, os.path.dirname(os.path.abspath(os.path.join(__file__, os.pardir))))
from Utils.IxLoadRestPyWrapper import *

import time

try:
    setEnvironment(ip='localhost', apiVersion='v0')  # TODO - to be changed by user
    session = IxSessionWrapper(version="version") # TODO - to be changed by user
    session.start()

    test = session.ixload.test
    chassisChain = session.ixload.chassischain
    chassisList = chassisChain.chassisList
    chassisList.clear()
    chassis = chassisList.appendItem(name="machine_ip") # TODO - to be changed by user
    chassis.refreshConnection()

    activeTest = session.ixload.test.activeTest
    activeTest.enableForceOwnership = True

    # create communities
    clientCommunity = activeTest.communityList.appendItem()
    serverCommunity = activeTest.communityList.appendItem()

    clientPortList = clientCommunity.network.portList
    serverPortList = serverCommunity.network.portList

    # add ports
    clientPortList.appendItem(chassisId=1, cardId=7, portId=1)
    serverPortList.appendItem(chassisId=1, cardId=7, portId=5)

    # create acitivies
    voipClientActivity = clientCommunity.activityList.appendItemIxActivityVoIPPeer()
    voipServerActivity = serverCommunity.activityList.appendItemIxActivityVoIPPeer()

    # edit scenario
    voipClientActivity.agent.pm.scenarioSettings.scenarioFile = "C:\\Path\\to\\TestScenario1.tst"
    voipServerActivity.agent.pm.scenarioSettings.scenarioFile = "C:\\Path\\to\\TestScenario1.tst"

    test.runTest()

    while activeTest.currentState != "Unconfigured":
        time.sleep(2)

except Exception as ex:
    print("Caught exception -> %s" % (str(ex)))
finally:
    session.closeSession()